DeflaterOutputStream (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.zip, class: DeflaterOutputStream
Keywords: java.util.zip.DeflaterOutputStream class

# Class DeflaterOutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
java.util.zip.DeflaterOutputStream

All Implemented Interfaces:
  `Closeable, Flushable, AutoCloseable`

Direct Known Subclasses:
  `GZIPOutputStream, ZipOutputStream`

public class DeflaterOutputStream extends FilterOutputStream
This class implements an output stream filter for compressing data in the "deflate" compression format. It is also used as the basis for other types of compression filters, such as GZIPOutputStream.

Unless otherwise noted, passing a `null` argument to a constructor or method in this class will cause a `NullPointerException` to be thrown.

## Compressor Usage

A `DeflaterOutputStream` created without specifying a compressor will create a compressor at construction time, and close the compressor when the output stream is closed.

If a compressor is specified when creating a `DeflaterOutputStream`, it is the responsibility of the caller to close the compressor after closing the output stream.

API Note:
  The `close()` method should be called to release resources used by this stream, either directly, or with the `try`-with-resources statement.
Since:
  1.1
See Also:
  - `Deflater`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected byte[]`
  `buf`
  Output buffer for writing compressed data.
  `protected Deflater`
  `def`
  Compressor for this stream.

  ### Fields declared in class FilterOutputStream

  `out`
  Modifier and Type
  Field
  Description
  `protected OutputStream`
  `out`
  The underlying output stream to be filtered.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DeflaterOutputStream(OutputStream out)`
  Creates a new output stream and compressor with the default compression level and a default buffer size.
  `DeflaterOutputStream(OutputStream out, boolean syncFlush)`
  Creates a new output stream and compressor with the default compression level, a default buffer size and the specified flush mode.
  `DeflaterOutputStream(OutputStream out, Deflater def)`
  Creates a new output stream with the specified compressor and a default buffer size.
  `DeflaterOutputStream(OutputStream out, Deflater def, boolean syncFlush)`
  Creates a new output stream with the specified compressor, flush mode and a default buffer size.
  `DeflaterOutputStream(OutputStream out, Deflater def, int size)`
  Creates a new output stream with the specified compressor and buffer size.
  `DeflaterOutputStream(OutputStream out, Deflater def, int size, boolean syncFlush)`
  Creates a new output stream with the specified compressor, buffer size and flush mode.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Writes remaining compressed data to the output stream and closes the underlying stream.
  `protected void`
  `deflate()`
  Writes next block of compressed data to the output stream.
  `void`
  `finish()`
  Finishes writing compressed data to the output stream without closing the underlying stream.
  `void`
  `flush()`
  Flushes the compressed output stream.
  `void`
  `write(byte[] b, int off, int len)`
  Writes an array of bytes to the compressed output stream.
  `void`
  `write(int b)`
  Writes a byte to the compressed output stream.

  ### Methods declared in class FilterOutputStream

  `write`
  Modifier and Type
  Method
  Description
  `void`
  `write(byte[] b)`
  Writes `b.length` bytes to this output stream.

  ### Methods declared in class OutputStream

  `nullOutputStream`
  Modifier and Type
  Method
  Description
  `static OutputStream`
  `nullOutputStream()`
  Returns a new `OutputStream` which discards all bytes.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### def

    protected Deflater def
    Compressor for this stream.

  - ### buf

    protected byte[] buf
    Output buffer for writing compressed data.

- ## Constructor Details

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater def, int size, boolean syncFlush)
    Creates a new output stream with the specified compressor, buffer size and flush mode.

    Closing this output stream will not close the given compressor.

    Parameters:
      `out` - the output stream
      `def` - the compressor ("deflater")
      `size` - the output buffer size
      `syncFlush` - if `true` the `flush()` method of this instance flushes the compressor with flush mode `Deflater.SYNC_FLUSH` before flushing the output stream, otherwise only flushes the output stream
    Throws:
      `IllegalArgumentException` - if `size <= 0`
    Since:
      1.7

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater def, int size)
    Creates a new output stream with the specified compressor and buffer size.

    The new output stream instance is created as if by invoking the 4-argument constructor `DeflaterOutputStream(out, def, size, false)`.

    Closing this output stream will not close the given compressor.

    Parameters:
      `out` - the output stream
      `def` - the compressor ("deflater")
      `size` - the output buffer size
    Throws:
      `IllegalArgumentException` - if `size <= 0`

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater def, boolean syncFlush)
    Creates a new output stream with the specified compressor, flush mode and a default buffer size.

    Closing this output stream will not close the given compressor.

    Parameters:
      `out` - the output stream
      `def` - the compressor ("deflater")
      `syncFlush` - if `true` the `flush()` method of this instance flushes the compressor with flush mode `Deflater.SYNC_FLUSH` before flushing the output stream, otherwise only flushes the output stream
    Since:
      1.7

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, Deflater def)
    Creates a new output stream with the specified compressor and a default buffer size.

    The new output stream instance is created as if by invoking the 3-argument constructor `DeflaterOutputStream(out, def, false)`.

    Closing this output stream will not close the given compressor.

    Parameters:
      `out` - the output stream
      `def` - the compressor ("deflater")

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out, boolean syncFlush)
    Creates a new output stream and compressor with the default compression level, a default buffer size and the specified flush mode.

    The compressor will be closed when this output stream is closed.

    Parameters:
      `out` - the output stream
      `syncFlush` - if `true` the `flush()` method of this instance flushes the compressor with flush mode `Deflater.SYNC_FLUSH` before flushing the output stream, otherwise only flushes the output stream
    Since:
      1.7

  - ### DeflaterOutputStream

    public DeflaterOutputStream(OutputStream out)
    Creates a new output stream and compressor with the default compression level and a default buffer size.

    The new output stream instance is created as if by invoking the 2-argument constructor `DeflaterOutputStream(out, false)`.

    The compressor will be closed when this output stream is closed.

    Parameters:
      `out` - the output stream

- ## Method Details

  - ### write

    public void write(int b) throws IOException
    Writes a byte to the compressed output stream. This method will block until the byte can be written.
    Overrides:
      `write` in class `FilterOutputStream`
    Parameters:
      `b` - the byte to be written
    Throws:
      `IOException` - if an I/O error has occurred

  - ### write

    public void write(byte[] b, int off, int len) throws IOException
    Writes an array of bytes to the compressed output stream. This method will block until all the bytes are written.
    Overrides:
      `write` in class `FilterOutputStream`
    Parameters:
      `b` - the data to be written
      `off` - the start offset of the data
      `len` - the length of the data
    Throws:
      `IOException` - if an I/O error has occurred
    See Also:
      - `FilterOutputStream.write(int)`

  - ### finish

    public void finish() throws IOException
    Finishes writing compressed data to the output stream without closing the underlying stream. Use this method when applying multiple filters in succession to the same output stream.
    Throws:
      `IOException` - if an I/O error has occurred

  - ### close

    public void close() throws IOException
    Writes remaining compressed data to the output stream and closes the underlying stream.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `FilterOutputStream`
    Throws:
      `IOException` - if an I/O error has occurred
    See Also:
      - `FilterOutputStream.flush()`
      - `FilterOutputStream.out`

  - ### deflate

    protected void deflate() throws IOException
    Writes next block of compressed data to the output stream.
    Throws:
      `IOException` - if an I/O error has occurred

  - ### flush

    public void flush() throws IOException
    Flushes the compressed output stream. If `syncFlush` is `true` when this compressed output stream is constructed, this method first flushes the underlying `compressor` with the flush mode `Deflater.SYNC_FLUSH` to force all pending data to be flushed out to the output stream and then flushes the output stream. Otherwise this method only flushes the output stream without flushing the `compressor`.
    Specified by:
      `flush` in interface `Flushable`
    Overrides:
      `flush` in class `FilterOutputStream`
    Throws:
      `IOException` - if an I/O error has occurred
    Since:
      1.7
    See Also:
      - `FilterOutputStream.out`